/* source file */

/* There are several debug code.
 * To use it uncomment the line  "#define __debug"
 * or add it in the header file
*/

#include "Tautolog.h"

/* global constants */
const char C_NUL = '0';
const char C_ONE = '1';
const char C_ANY = '-';
unsigned int _TERM_SIZE = 0;	/* number of term variables */
unsigned long memory_size = 0;	/* for quick checking if the memory is empty*/
struct memory *top;


int isEmpty()
{
	return !memory_size;
}

/** Funcion add string "input" to the top of the struct memory */
int add(char* input)
{
	struct memory* pom;


	#ifdef __debug
		cout << "Pridavam do pameti:<" << input << ">" << endl;
	#endif

	if((pom = (struct memory*)malloc(sizeof(struct memory))) == NULL)	/* create new struct*/
	{

		#ifdef __debug
			cout << "... nepodarilo se to. :-(" << endl;
		#endif

		return 0;
	}
	pom->next = top;			/* add the new one to the struct*/
	top = pom;
	top->buffer = input;			/* input buffer to the struct*/
	//top->buffer[_TERM_SIZE]='\0';

	memory_size++;				/* counter of memory */
	#ifdef __debug
		cout << " ... uspesne ulozeno. :-)" << endl;
	#endif
	return 1;
} /* bool add(...) */






/** look for "input" string in the struct memory begining by "begin" or "top" if missing */
struct memory* find(const char* input, struct memory* begin)
{
	struct memory *pom;
		  unsigned int i;
	if(!memory_size)		/* memory is empty */
		return NULL;
	pom = begin;
	#ifdef __debug
		cout << "Hledam v pameti: <" << input << ">" << endl;
	#endif
	while(pom)
	{
		int found = 1;	/* break cyclus if nessesery*/

		for(i=0 ; i < _TERM_SIZE; ++i)
		{
			if(input[i] != pom->buffer[i])	/* compare and check*/
				if((pom->buffer[i] != C_ANY)&&(input[i]!=C_ANY))
				{
						found = 0;
					break;
				}
		}
		if(found)	/* it was found there */
			break;
		pom = pom->next;
	}
	#ifdef __debug
		if(pom)
			cout << "Nalezeno:<" << pom->buffer << ">"<< endl;
		else
			cout << "Nenalezeno." << endl;
#endif
	return pom;	/* return reference to a memory struct*/
} /* struct memory* find(...) */






/** Clean alocated structures in memory */
void clearMem(void)
{
	struct memory* pom;
	#ifdef __debug
		cout << "Promazavam pamet:<";
	#endif
	pom = top;

	while(top)	/* begin on top */
	{
		top = top->next;	/* move to the next*/
		free(pom->buffer);
		free(pom);
		pom = top;
		#ifdef __debug
			cout << ".";		/* draw a point - like a visual counter ;-)*/
		#endif
	}
	memory_size = 0;	/* memory is empty right now*/
	#ifdef __debug
		cout << "> ...uspesne. :-)" <<  endl;
	#endif

} /* void clearMem() */





/** Initialize memory */
int initMem(void)
{
	unsigned int i;
	char *universum;	/* this will be a term "-----" this mean that it is everything*/

	#ifdef __debug
		cout << "Inicializuji pamet:" << endl;
	#endif
	memory_size = 0;
	top = NULL;

	if((universum = (char*) malloc(_TERM_SIZE+1))==NULL)
	{			/* create universum */
		#ifdef __debug
			cout << " Chyba pri vytvareni struktury. :-(" << endl;
		#endif
		return 0;
	}
	for(i = 0; i < _TERM_SIZE; ++i)
		universum[i] = C_ANY;	/* fill the universum of character "-"*/
	universum[_TERM_SIZE] = '\0';	/* end of string */
	if(!add(universum))		/* add it into the memory*/
	{
		free(universum);	/* something fail in adding*/
		return 0;
	}
	#ifdef __debug
		cout << " Uspesne inicializovana pamet. :-)" << endl;
	#endif
	return 1;
} /* bool initMem() */





/** save result to the file - save all what is in memory and say if it is a tautology or not*/
void storeToFile(ofstream& f)
{
	struct memory* pom;
	pom = top;
	if(memory_size)			/* result of the memory */
	{
		f << "Vstupni data nejsou tautologie." << endl;
		#ifdef __debug
			cout << "Vstupni data nejsou tautologie." << endl;
		#endif
	}
	else
	{
		f << "Vstupni data jsou tautologie." << endl;
		#ifdef __debug
			cout << "Vstupni data jsou tautologie." << endl;
		#endif
	}
	#ifdef __debug
		cout << "Ukladam do souboru verdikt:<";
	#endif
	while(pom)	/* print all */
	{
		f << pom->buffer << endl;
		pom = pom->next;
		#ifdef __debug
			cout << ".";	/* the visual efekt of counting :-)*/
		#endif
	}
	#ifdef __debug
		cout << "> uspesne ulozeno. :-)" << endl;
	#endif
} /* void storeToFile(...)*/




/** initialize term size ->read first line in the file and setup the variable "_TERM_SIZE" */
int set_TERM_SIZE(ifstream& f)
{
	char buf[25];	/* this is buffer where it will read to.*/

	f.get(buf,3);
	#ifdef __debug
		cout << buf;
	#endif
	if((buf[0]  =='.')&&(buf[1]  =='i'))
	{
		f >> _TERM_SIZE;
		#ifdef __debug
			cout << "Nastavuji velikost termu:" << _TERM_SIZE << endl;
		#endif
	}
	f.getline(buf,25);
	#ifdef __debug
		cout << buf;
	#endif
	f.getline(buf,25);
	#ifdef __debug
		cout << buf;
	#endif
	return 1;
} /*bool set_TERM_SIZE(...) */




/** load next line from the file and return the term string */
char* loadNextFromFile(ifstream& f)
{
	char *buf =(char*) malloc(_TERM_SIZE+1);	/* alloc a memory for term */
	char c[255];

	#ifdef __debug
		cout << "Ctu ze souboru term: ";
	#endif

	f.get(buf,_TERM_SIZE+1);		/* read line */
	buf[_TERM_SIZE]='\0';
	if((buf[0] == '.')&&(buf[1] == 'e'))
	{
		#ifdef __debug
			cout << "\n Konec vsupnich dat. Dalsi uz nejsou. :-(" << endl;
		#endif
		return NULL;
	}
	f.getline(c,254);	/* move to the next line */

	#ifdef __debug
		cout << "<" <<buf << ">" <<endl;
	#else
		cout << ".";
	#endif
	return buf;
} /* char* loadNextFromFile(...) */





/** delete one record from memory on pointer "kde" */
struct memory* deleteThis(struct memory* kde)
{
	struct memory* pom;
	if(!kde)	/* if there is something to delete */
		return kde;
	#ifdef __debug
		cout << "Mazu z pameti: <" << kde->buffer << ">";
	#endif
	memory_size--;
	pom = top;
	if(kde == top)		/* top is the first of record it need to be reseted */
	{
		if(pom->next)	/* if top is also the last record -> there is only one */
		{
			pom = top->next;
			free(top->buffer);
			top->next = pom->next;
			top->buffer = pom->buffer;
			free(pom);
		}
		else
		{
			free(pom->buffer);	/* clear string */
			free(pom);		/* clear struct */
			top = NULL;
			kde = NULL;
		}
		#ifdef __debug
			cout << "... uspesne smazano. :-)";  
		#endif
	}
	else
	{
		if(kde ->next)
		{	
			free(kde->buffer);
			pom = kde->next;
			kde->buffer = pom->buffer;
			kde->next = pom->next;
			free(pom);
		}else
		{
			while(pom->next!=kde)	/* if it is in the middle -> we need to find previous */
				pom = pom->next;
			pom->next = NULL;
			free(kde->buffer);
			free(kde);
			kde = NULL;
		}
		#ifdef __debug
			cout << ".. uspesne smazano. :-)" << endl;
		#endif
	}
	return kde;
} /* void deleteThis(...) */





/** this cut from the term part of the subterm - info in documentation file */
void separate(const char* co,struct memory* kde)
{
	unsigned int i;
	unsigned int citac = 0;
	#ifdef __debug
		cout << "Odcitam: <"<< co << "> z: <" << kde->buffer << ">" << endl;
	#endif
	for(i=0 ; i < _TERM_SIZE; ++i)		/* compute number of new parts*/
		if(co[i] != C_ANY && kde->buffer[i] == C_ANY)
			citac++;
	if(!citac)
		kde = deleteThis(kde);	/*no new part, term is all in searched term */
	else
	{
		unsigned int position = 0;

		if(citac > 1)	/* if there is only one part we don't need to create new one*/
		{
			while(citac > 1)	/* create new term from main term in memory */
			{
				if(co[position] != C_ANY && kde->buffer[position] == C_ANY)
				{
					char *maska =(char*) malloc(_TERM_SIZE+1);

					for(i = 0; i < _TERM_SIZE + 1 ; ++i)
					maska[i] = kde->buffer[i]; /* copy main into new this */
					maska[position] = (co[position]==C_NUL)?C_ONE:C_NUL;	/* like a magic :-)*/
					kde->buffer[position] = (co[position]==C_NUL)?C_NUL:C_ONE; /* like a magic :-)*/
					maska[_TERM_SIZE]='\0';
					add(maska);	/* add the new one to the memory*/
					citac--;
				}
				position++;	/* increase next changing position in term */
			}
		}
		do	/* change the last different position */
		{
			if(co[position] != C_ANY && kde->buffer[position] ==C_ANY)
			{
				kde->buffer[position] = (co[position]==C_NUL)?C_ONE:C_NUL; /* like a magic :-)*/
				break;
			}
		} while(++position < _TERM_SIZE);	/*while not an end of term (string)*/
		kde->buffer[_TERM_SIZE] = '\0';
	}
	#ifdef __debug
		cout << "Odecteno. :-)" << endl ;
	#endif
} /* void separate(...) */